<?php
/**
 * @version		$Id: password_form.php,v 1.6 2012-06-05 23:22:16 juanca Exp $
 * @package		VPL. Get password to access form
 * @copyright	2012 Juan Carlos Rodríguez-del-Pino
 * @license		http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 * @author		Juan Carlos Rodríguez-del-Pino <jcrodriguez@dis.ulpgc.es>
 */

global $CFG;
require_once $CFG->libdir.'/formslib.php';
class mod_vpl_password_form extends moodleform {
	function definition(){
		global $SESSION;
		$mform    =& $this->_form;    
        $mform->addElement('header', 'headerpassword', get_string('requiredpassword', VPL));
        $mform->addElement('hidden','id',required_param('id',PARAM_INT));
        $submissionid=optional_param('submissionid',0,PARAM_INT);
        if($submissionid>0){
        	$mform->addElement('hidden','submissionid',$submissionid);
        }
        $popup=optional_param('popup',0,PARAM_INT);
        if($popup>0){
        	$mform->addElement('hidden','popup',$popup);
        }
        $fullscreen=optional_param('fullscreen',0,PARAM_INT);
        if($fullscreen>0){
        	$mform->addElement('hidden','fullscreen',$fullscreen);
        }
        $mform->addElement('password', 'password', get_string('password') );
        $mform->setType('password', PARAM_TEXT);
        $mform->setDefault('password', '');
        if(isset($SESSION->vpl_attempt_number)){
        	$mform->addElement('static', 'attempt_number','', get_string('attemptnumber',VPL,$SESSION->vpl_attempt_number) );
        }
        $this->add_action_buttons();
	}
}
?>